/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 11.6 (Uniform-Sphere, p. 253)
 *
 * this file: algo11_06.c
 *
 * For a demo how to use this algorithm see the file "demo_algo11_06.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"
#include "algo.h"


void generator11_06(int d, double x[])
/* 
 * Algorithm 11.6 (Uniform-Sphere, p. 253)
 * generates a random vector on the sphere S^(d-1)
 * d ... length of the generated vectors
 * x ... is the array to hold the generated vector     
 */
{     int i;
      double s;

      s = 0.;
/*1*/ for(i=1;i<=d;i++){
        x[i]=generator02_11();
        s+=x[i]*x[i];
      }
/*2*/ s = sqrt(s);
/*3*/ for(i=1;i<=d;i++) x[i] = x[i]/s;
}

