/*
 * Hormann, Leydold, Derflinger
 * Automatic Nonuniform Random Variate Generation
 * Springer, Heidelberg, New York, 2003
 * http://statistik.wu-wien.ac.at/arvag/monograph
 * 
 * Code for Algorithm 12.7 (Zero-Maximal-Bivariate), p. 331 
 *
 * this file: algo12_07.c
 *
 * For a demo how to use this algorithm see the file "demo_algo12_07.c".
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "uniform.h"
#include "algo.h"


void generator12_07(double rho, double res[2])
/*
 * Algorithm 12.7 (Zero-Maximal-Bivariate), p. 331 
 *
 * rho .... Correlation 
 * res[2] ... to hold the result
 *
 */
#define U res[0]
#define V res[1]
{
 double W;   

/*1*/ U = uniform();
      W = uniform();
/*2*/ if( W < fabs(rho)){
/*3*/   if( rho > 0. ) 
/*4*/     V = U;
/*5*/   else 
/*6*/     V = 1. - U;
      }
/*7*/ else
/*8*/   V = uniform();
}
#undef U
#undef V
