
double pdf_tri(double x);
/* PDF for the triangular distribution on (0,1) */
double cdf_tri(double x);
/* CDF for the triangular distribution on (0,1) */
double pdf_tri2(double x);
/* PDF for a second triangular distribution on (0,1) */
double cdf_tri2(double x);
/* CDF for the second triangular distribution on (0,1) */

double pdf_halfnorm(double x);
/* pdf of the standard normal distribution restricted to positive values*/
double cdf_halfnorm(double x);
/* CDF of the standard normal distribution restricted to positive values*/

double pdf_oox1_3(double x);
/* density 1/x on (1,3) */
double dpdf_oox1_3(double x);
/* derivative of the density 1/x on (1,3) */
double cdf_oox1_3(double x);
/* CDF for density 1/x on (1,3) */

double cdf_cauchy(double x);
/* CDF of Cauchy distribution */

double pdf_gamma3(double x);
/* PDF of gamma distribution with shape parameter alpha = 3 */
double cdf_gamma3(double x);
/* CDF of Gamma distribution with shape parameter alpha=3 */

double cdf_normal(double x); 
/* CDF of standard normal distribution */
double pdf_normal(double x);
/* PDF of standard normal distribution */
double dpdf_normal(double x);
/* derivative of the PDF of standard normal distribution */
double ddpdf_normal(double x);
/* second derivative of the PDF of standard normal distribution */

double cdf_weibull(double x, double alpha, double beta);
     /* cdf of the Weibull distribution */
double cdf_pareto(double x, double a);
     /* cdf of the Pareto distribution */
double cdf_chia(double x,int n);             
/* approximate cdf of the chi2 distribution */

double chi2test(long b[]/*obsereved frequencies*/, 
                long l,/*number of classes*/
		long wid,/*sample size*/ 
		       int printflag/*0..no output, 1.. little, 2..more*/);

void printmatrix(int d, double M[]);
/* prints a square matrix that is stored in a vector of length (d+1)^2 */

double lnkfakt(int k);
     /* evaluates log(k!) */
/**************************************/

/*for computing correlations*/
typedef struct{
  double mx,my,sx,sy,sxy;
  int i,cookie;
} MEANCOR;

MEANCOR *init_meancor();
/* 
 * allocates and initializes a structure necessary to compute the correlation
 * returns a pointer to that structure
 */
void free_meancor(MEANCOR *p);
/* frees the allocated memory */

void update_meancor(MEANCOR *p, double xi, double yi);
/* adds the pair (xi,yi) to the sample for which the correlation is computed */

void printresult_meancor(MEANCOR *p);
/* prints the current value of the correlation */

